;**************************************************************************
;*
;* FILE  kernalpatcher.asm
;* Copyright (c) 2006, 2007 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: kernalpatcher.asm,v 1.42 2007-06-24 16:14:39 tlr Exp $
;*
;* DESCRIPTION
;*   Create a patched kernal.
;*
;******
	processor 6502

;CONF_USERPORT	equ	1	

	MAC	sac
	dc.b	$32,{1}
	ENDM
	MAC	sir
	dc.b	$42,{1}
	ENDM
	MAC	bra
_TMPBRA	set	{1}-2-.
	if	_TMPBRA < -128 || _TMPBRA > 127
	ERR 	"Branch to long!"
	endif
	dc.b	$12,_TMPBRA
	ENDM

PATCH_VERSION	equ	$10
	
	seg.u	zp
;**************************************************************************
;*
;* SECTION  zero page
;*
;******
	org	$69
src_zp:
	ds.w	1
dest_zp:
	ds.w	1
len_zp:
	ds.w	1
	org	$a5
tmpptr_zp:
	ds.b	3
rawmode_zp:
	ds.b	1
tmp3_zp:
	ds.b	1
	
	org	$b0
fptr_zp:
	ds.b	3
eptr_zp:
	ds.b	3
bank_zp:	
	ds.b	1

	org	$bd
tmp_zp:
	ds.b	1
tmp2_zp:
	ds.b	1

	org	$f7
xtmp_zp:
	ds.b	1
ytmp_zp:	
	ds.b	1
ptr_zp:	
	ds.w	1
ptr2_zp:	
	ds.w	1
rptr_zp:
	ds.b	3


	seg	data
	org	code_end

	seg.u	bss
	org	data_end
				
	seg	code
	org	$0801
;**************************************************************************
;*
;* Basic line!
;*
;******
StartOfFile:
	dc.w	EndLine
	dc.w	0
	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
EndLine:
	dc.w	0
	
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:
; restore system state after decrunch or similar
RESTORE	equ	1
	include	"sys.asm"
; fix screen
	jsr	$ff5b

; default to device number 8 if it was 0
	lda	$ba
	bne	sa_skp1
	lda	#8
	sta	$ba
sa_skp1:

	sei
; current kernal ($e000) into kernal_buffer ($20 pages)
	lda	#$e0
	ldy	#>kernal_buffer
	ldx	#$20
sa_sm1:
	jsr	mr_copy
; only the first time.
	lda	#$2c
	sta	sa_sm1
	cli
	
	jsr	init_video

sa_lp3:
	jsr	print_header
sa_update2:
	jsr	print_footer
	ldy	#0
	ldx	#3
	clc
	jsr	$fff0
	lda	#<menu_msg
	ldy	#>menu_msg
	jsr	print

sa_update:
	ldy	#0
	ldx	#13
	clc
	jsr	$fff0

sa_lp1:
	jsr	$ffe4
	beq	sa_lp1
	ldx	#0
sa_lp2:
	cmp	key_tab,x
	beq	sa_found
	inx
	inx
	inx
	cpx	#key_tab_len
	bne	sa_lp2
	jmp	sa_lp1

sa_found:
	lda	key_tab+2,x
	pha
	lda	key_tab+1,x
	pha
	rts
	
key_tab:	
	dc.b	"X"
	dc.w	cmd_exit-1
	dc.b	"C"
	dc.w	cmd_create_patch-1
	dc.b	"L"
	dc.w	cmd_load_data-1
	dc.b	"S"
	dc.w	cmd_save_data-1
	dc.b	"W"
	dc.w	cmd_save_ram_kernal-1
	dc.b	"V"
	dc.w	cmd_save_soft_kernal-1
	dc.b	"$"
	dc.w	cmd_directory-1
	dc.b	"8"
	dc.w	cmd_set_drive8-1
	dc.b	"9"
	dc.w	cmd_set_drive9-1
	dc.b	"H"
	dc.w	cmd_help_text-1
	dc.b	"T"
	dc.w	cmd_test_kernal-1
key_tab_len	equ	.-key_tab
	
cmd_exit:
	lda	#<exit_msg
	ldy	#>exit_msg
	jsr	print
	jmp	$a474


sa_wait_key:	
	lda	#<anykey_msg
	ldy	#>anykey_msg
	jsr	print
sa_lp4:
	jsr	$ffe4
	beq	sa_lp4
sa_exit_refresh:
	jmp	sa_lp3
sa_exit_refresh2:
	jmp	sa_update2


;**************************************************************************
;*
;* NAME  print_header
;*
;* DESCRIPTION
;*   show the screen heading and footer
;*
;******
print_header:
	lda	#<header_msg
	ldy	#>header_msg
	jsr	print

	ldy	#0
	ldx	#23
	clc
	jsr	$fff0
	lda	#<footer_msg
	ldy	#>footer_msg
	jsr	print
	rts
header_msg:
	dc.b	147
	dc.b	"DTV PAL/HUMMER KERNAL PATCHER V1.0 / TLR"
	ds.b	40,195
	dc.b	0

footer_msg:
	ds.b	40,195
	dc.b	"                              DRIVE #  "
	dc.b	0

;**************************************************************************
;*
;* NAME  print_footer
;*
;* DESCRIPTION
;*   Update footer status info
;*
;******
print_footer:
; Print device num
	ldy	#37
	ldx	#24
	clc
	jsr	$fff0
	ldx	$ba
	lda	#0
	jsr	$bdcd	
	ldy	$d3
	lda	#" "
	sta	($d1),y
	rts

;**************************************************************************
;*
;* NAME  clear_menu
;*
;* DESCRIPTION
;*   Clear the central screen area.
;*
;******
clear_menu:
; reset link table
	lda	$0288	;screen base
	ora	#$80
	tay
	lda	#0
	tax
cm_lp1:
	sty	$d9,x
	clc
	adc	#40
	bcc	cm_skp1
	iny
cm_skp1:
	inx
	cpx	#26
	bne	cm_lp1
	lda	#$ff
	sta	$d9,x

	ldx	#2
cm_lp2:
	jsr	$e9ff
	inx
	cpx	#23
	bne	cm_lp2

; put cursor at 0,2
	ldy	#0
	ldx	#2
	sty	$d3
	stx	$d6
	jmp	$e56c		; update screen ptr

;**************************************************************************
;*
;* NAME  init_video
;*
;* DESCRIPTION
;*   Only called the first time the program is run.
;*
;******
init_video:
	jsr	$ff5b
	lda	#6
	sta	$d020
	lda	#0
	sta	$d021
	lda	#1
	sta	646
	rts

;**************************************************************************
;*
;* NAME  cmd_set_drive8, cmd_set_drive9
;*
;* DESCRIPTION
;*   set drive numbers.
;*
;******
cmd_set_drive8:
	lda	#8
	dc.b	$2c
cmd_set_drive9:
	lda	#9
	sta	$ba
	jmp	sa_exit_refresh2

;**************************************************************************
;*
;* NAME  cmd_help_text
;*
;* DESCRIPTION
;*   display help text.
;*
;******
cmd_help_text:
	ldx	#<helptext
	ldy	#>helptext
	jsr	show_help
	jmp	sa_exit_refresh
	
;**************************************************************************
;*
;* NAME  cmd_directory
;*
;* DESCRIPTION
;*   show directory listing
;*
;******
cmd_directory:
	lda	#147
	jsr	$ffd2
	jsr	show_dir
	jmp	sa_wait_key

;**************************************************************************
;*
;* NAME  show_dir
;*
;* DESCRIPTION
;*   show directory listing
;*
;******
show_dir:

; initialize and open
	lda	#1
	ldx	#<dir_msg
	ldy	#>dir_msg
	jsr	$ffbd	;SETNAM
	lda	#1
	ldx	$ba
	ldy	#$60
	jsr	$ffba	;SETLFS
	jsr	$ffc0	;OPEN
	lda	$ba
	jsr	$ffb4	;TALK
	lda	$b9
	jsr	$ff96	;TKSA

	ldy	#$03
sdr_lp1:
	sty	sdr_tmp
sdr_lp2:
	jsr	$ffa5	;ACPTR
	sta	sdr_linenum
	jsr	$ffa5	;ACPTR
	sta	sdr_linenum+1
	ldy	$90
	bne	sdr_ex1
	dec	sdr_tmp
	bne	sdr_lp2
	jsr	sdr_outputdecimal
	lda	#" "
	jsr	$ffd2	;CHROUT
sdr_lp3:
	jsr	$ffa5	;ACPTR
	ldx	$90
	bne	sdr_ex1
	cmp	#0
	beq	sdr_skp1
	jsr	$ffd2	;CHROUT
	jmp	sdr_lp3
sdr_skp1:
	lda	#13
	jsr	$ffd2	;CHROUT
	ldy	#$02
sdr_lp4:
	jsr	$ffe1	;STOP
	bne	sdr_lp1

sdr_ex1:

;*
;* exit, clean up
;*
	jsr	$ffab	;UNTLK
	lda	#1
	jsr	$ffc3	;CLOSE
	jsr	$ffe7	;CLALL
	clc
	rts

sdr_linenum:
	dc.w	0
sdr_tmp:
	dc.b	0

sdr_outputdecimal:
	ldx	sdr_linenum
	lda	sdr_linenum+1
	jsr	$bdcd	;Output decimal number
	rts

dir_msg:
	dc.b	"$"

;**************************************************************************
;*
;* NAME  cmd_create_patch
;*
;* DESCRIPTION
;*
;******
cmd_create_patch:
	lda	#147
	jsr	$ffd2

; copy original kernal3
	lda	#<kernal3
	sta	src_zp
	lda	#>kernal3
	sta	src_zp+1
	lda	#>kernal_buffer
	sta	dest_zp+1
	ldx	#$20		; $20 pages
	ldy	#0
	sty	dest_zp
ccp_lp1:
	lda	(src_zp),y
	eor	#$aa
	sta	(dest_zp),y
	iny
	bne	ccp_lp1
	inc	src_zp+1
	inc	dest_zp+1
	dex
	bne	ccp_lp1

; apply original dtv2 patches
	ldx	#<dtv2_patch
	ldy	#>dtv2_patch
 	jsr	applypatch	
	
; ask if dtv or hummer game.
	lda	#<dtv_hummer_msg
	ldy	#>dtv_hummer_msg
	jsr	print
	lda	#"D"
ccp_erlp:
	ldx	$d3
	jsr	$ffd2
	stx	$d3
	stx	xtmp_zp
	jsr	$ffcf
	ldx	xtmp_zp
	stx	$d3
	cmp	#"D"
	beq	ccp_skpb
	cmp	#"H"
	beq	ccp_skpc
	lda	#"?"
	bra	ccp_erlp

ccp_skpb:	
	lda	#<dtv_msg
	ldy	#>dtv_msg
	ldx	#0
	bra	ccp_skpd
ccp_skpc:
	lda	#<hummer_msg
	ldy	#>hummer_msg
	ldx	#1
ccp_skpd:
	stx	hummer_flag
	jsr	print
	jsr	print_cr
		
; reverse ctrl function.
	lda	#<reversectrl_msg
	ldy	#>reversectrl_msg
	jsr	print
	lda	#"N"
	ldx	hummer_flag
	beq	ccp_skpz
	lda	#"Y"
ccp_skpz:
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skp1

;F9A4 78         SEI
;F9A5 A9 7F      LDA #$7F
;F9A7 8D 00 DC   STA $DC00
;F9AA AD 01 DC   LDA $DC01
;F9AD 29 04      AND #$04
;F9AF D0 13      BNE $F9C4	-> F9AF F0 13      BEQ $F9C4
;F9B1 58         CLI
	lda	#$f0
	sta	kernal_buffer+$19af

ccp_skp1:

; load routine patch.
	lda	#<loadpatch_msg
	ldy	#>loadpatch_msg
	jsr	print
	lda	#"Y"
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skpa
	ldx	#<load_patch
	ldy	#>load_patch
 	jsr	applypatch	
ccp_skpa:

; apply the flash reset vector hack + directory search fix.
	lda	#<flashhook_msg
	ldy	#>flashhook_msg
	jsr	print
	lda	#"Y"
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skp2

; Hummer mode main patch
	ldx	#<main_hummer_patch
	ldy	#>main_hummer_patch
	lda	hummer_flag
	bne	ccp_skpq
; DTV mode main patch
	ldx	#<main_patch
	ldy	#>main_patch
ccp_skpq:
 	jsr	applypatch	
ccp_skp2:

; hardcode video timing.
	lda	#<hardvideo_msg
	ldy	#>hardvideo_msg
	jsr	print
	lda	#"Y"
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skp3

	ldx	#<hardvideo_patch
	ldy	#>hardvideo_patch
 	jsr	applypatch	

	lda	hummer_flag
	bne	ccp_skpe
; read pal defaults from the user port
	IFCONST	CONF_USERPORT
	jsr	clone_f951
	ELSE	;CONF_USERPORT
; pal defaults
	ldx	#5
ccp_lpe:
	lda	pal_defaults,x
	sta	tmp_d040,x
	dex
	bpl	ccp_lpe
	ENDIF	;CONF_USERPORT
	bra	ccp_skpf
ccp_skpe:
; hummer defaults
	ldx	#5
ccp_lpf:
	lda	ntsc_defaults,x
	sta	tmp_d040,x
	dex
	bpl	ccp_lpf

ccp_skpf:
;F95B A9 00      LDA #$00
;F95D 8D 40 D0   STA $D040
;F960 A9 00      LDA #$00
;F962 8D 41 D0   STA $D041
;F965 A9 00      LDA #$00
;F967 8D 42 D0   STA $D042
;F96A A9 00      LDA #$00
;F96C 8D 43 D0   STA $D043
;F96F A9 00      LDA #$00
;F971 8D 4E D0   STA $D04E
;F974 A9 00      LDA #$00
;F976 8D 4F D0   STA $D04F

	lda	#<video_d040_msg
	ldy	#>video_d040_msg
	jsr	print
	lda	tmp_d040
	jsr	input_byte_pre
	sta	kernal_buffer+$195c
	
	lda	#<video_d041_msg
	ldy	#>video_d041_msg
	jsr	print
	lda	tmp_d041+2
	ldy	tmp_d041+1
	ldx	tmp_d041
	jsr	input_triplet_pre
	sta	kernal_buffer+$196b
	sty	kernal_buffer+$1966
	stx	kernal_buffer+$1961

	lda	#<video_d04e_msg
	ldy	#>video_d04e_msg
	jsr	print
	lda	tmp_d04e
	jsr	input_byte_pre
	sta	kernal_buffer+$1970
	
	lda	#<video_d04f_msg
	ldy	#>video_d04f_msg
	jsr	print
	lda	tmp_d04f
	jsr	input_byte_pre
	sta	kernal_buffer+$1975

	jsr	print_cr
		
ccp_skp3:

; apply zee/pepto palette.
	lda	#<palette_msg
	ldy	#>palette_msg
	jsr	print
	lda	#"Y"
	ldx	hummer_flag
	beq	ccp_skp6
	lda	#"N"
ccp_skp6:
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skp4
	ldx	#<palette_patch
	ldy	#>palette_patch
 	jsr	applypatch	
	
ccp_skp4:

; apply auto load patch.
	lda	#<autoload_msg
	ldy	#>autoload_msg
	jsr	print
	lda	#"N"
	jsr	input_y_n_pre
	pha
	jsr	print_cr
	pla
	cmp	#"Y"
	bne	ccp_skp5
	ldx	#<softboot_patch
	ldy	#>softboot_patch
 	jsr	applypatch	
	
ccp_skp5:

; set version number
	lda	#PATCH_VERSION
	sta	kernal_buffer+$1878

; all done!
	lda	#<patches_applied_msg
	ldy	#>patches_applied_msg
	jsr	print
	jmp	sa_wait_key


	IFCONST	CONF_USERPORT
;**************************************************************************
;*
;* NAME  clone_f951
;*
;* DESCRIPTION
;*   Clone of the DTV video init at $f951.
;*
;******
clone_f951:
        lda     #$00
        sta     $dd03
        lda     $dd01
        sta     $aa
        and     #$03
        sta     tmp_d040
        lda     $aa
        lsr
        lsr
        and     #$0f
        sta     tmp_d04f
        bit     $aa
        bvs     cri_skp1
        lda     #7
        dc.b    $2c
cri_skp1:
        lda     #6
        sta     tmp_d04e
        bit     $aa
        bmi     cri_skp2
        ldy     #$02
        dc.b    $2c
cri_skp2:
        ldy     #$05
        lda     $01
        and     #$10
        bne     cri_skp3
        tya
        clc
        adc     #$06
        tay
        lda     #$00
        sta     tmp_d04e
cri_skp3:
        ldx     #$2
cri_lp1:
        lda     consts,y
        sta     tmp_d041,x
        dey
        dex
        bpl     cri_lp1
        rts
consts:
        dc.b    $1c,$13,$2a
        dc.b    $24,$31,$5b
        dc.b    $1c,$00,$00
        dc.b    $24,$00,$00
	ENDIF	;CONF_USERPORT

pal_defaults:
	dc.b	$03,$24,$00,$00,$00,$02
ntsc_defaults:
	dc.b	$00,$1c,$00,$00,$0a,$02
tmp_d040:
	dc.b	0
tmp_d041:
	dc.b	0,0,0
tmp_d04e:
	dc.b	0
tmp_d04f:
	dc.b	0

;**************************************************************************
;*
;* NAME  cmd_load_data
;*
;* DESCRIPTION
;*   read status from the flash and present to screen.
;*
;******
cmd_load_data:
	lda	#<loadfile_msg
	ldy	#>loadfile_msg
	jsr	print

cld_lp2:
	lda	#<filename_msg
	ldy	#>filename_msg
	jsr	print
	jsr	input_filename
	jsr	print_cr

;check length, exit if = 0
	lda	$b7
	bne	cld_skp4
	jmp	sa_exit_refresh

cld_skp4:
;check if directory
	ldy	#0
	lda	($bb),y
	cmp	#"$"
	bne	cld_skp3

	jsr	print_cr
	jsr	show_dir
	jsr	print_cr
	jmp	cld_lp2

cld_skp3:
	lda	#<rawdata_msg
	ldy	#>rawdata_msg
	jsr	print
	lda	#"N"
	jsr	input_y_n_pre
	sta	rawmode_zp
	jsr	print_cr
	
; use last accessed device
	lda	#1
	ldx	$ba
	ldy	#0		; read
	jsr	$ffba

; Print "SEARCHING FOR <name>"  (skipping the direct mode check at $f5af)
 	jsr	$f5b3		

; open the file.
	jsr	$ffc0

; make it default input
	ldx	#1
	jsr	$ffc6

	lda	rawmode_zp
	cmp	#"Y"
	beq	cld_skp2
; skip the load address
	jsr	$ffe4
	jsr	$ffe4
cld_skp2:

	lda	#<kernal_buffer
	sta	rptr_zp
	lda	#>kernal_buffer
	sta	rptr_zp+1
				
; Print "LOADING"  (skipping the direct mode check at $f5d2)
	ldy	#$49
 	jsr	$f12f

; load data
	ldy	#0
cld_lp1:
	jsr	$ffe4
	sta	(rptr_zp),y

	lda	$90		; check status, exit if fail
	and	#%10000011
	bne	cld_fl1

	inc	rptr_zp
	bne	cld_skp1
	inc	rptr_zp+1
cld_skp1:
	
; check for end of file
	bit	$90
	bvc	cld_lp1		;if not finished... loop!

	lda	#0
cld_fl1:	
	php
; restore default input
	jsr	$ffcc
; and close file
	lda	#1
	jsr	$ffc3

	jsr	print_cr

; pop the status and check
	plp
	bne	cld_fl2

cld_ex2:
	lda	#<ok_msg
	ldy	#>ok_msg
cld_ex1:
	jsr	print
	jmp	sa_wait_key

cld_fl2:
	lda	#<dfailed_msg
	ldy	#>dfailed_msg
	jmp	cld_ex1


;**************************************************************************
;*
;* NAME  cmd_save_soft_kernal
;*
;* DESCRIPTION
;*
;******
cmd_save_soft_kernal:
	lda	#<savesoftkernal_msg
	ldy	#>savesoftkernal_msg
	jsr	print
	lda	#<flash_addr_msg
	ldy	#>flash_addr_msg
	jsr	print
	lda	#$00
	ldy	#$e0
	ldx	#$1f
	jsr	input_triplet_pre
; only msb used
	txa
	sta	soft_kernal_start+[sk_sm1-rk_sysline]+1

	jsr	print_cr
	jsr	print_cr
cssd_lp2:
	lda	#<filename_msg
	ldy	#>filename_msg
	jsr	print
	jsr	input_filename
	jsr	print_cr

;check length, exit if = 0
	lda	$b7
	bne	cssd_skp4
	jmp	sa_exit_refresh

cssd_skp4:
;check if directory
	ldy	#0
	lda	($bb),y
	cmp	#"$"
	bne	cssd_skp3

	jsr	print_cr
	jsr	show_dir
	jsr	print_cr
	jmp	cssd_lp2

cssd_skp3:
	lda	#"N"
	sta	rawmode_zp

	lda	#<sk_sysline
	sta	ptr_zp
	lda	#>sk_sysline
	sta	ptr_zp+1
	lda	#<soft_kernal_start
	sta	rptr_zp
	lda	#>soft_kernal_start
	sta	rptr_zp+1
	lda	#<soft_kernal_end
	sta	eptr_zp
	lda	#>soft_kernal_end
	sta	eptr_zp+1
	jmp	cmd_save_data_common
	
;**************************************************************************
;*
;* NAME  cmd_save_ram_kernal
;*
;* DESCRIPTION
;*
;******
cmd_save_ram_kernal:
	lda	#<saveramkernal_msg
	ldy	#>saveramkernal_msg
	jsr	print
		
	lda	#<ram_addr_msg
	ldy	#>ram_addr_msg
	jsr	print
	lda	#$00
	ldy	#$e0
	ldx	#$1e
	jsr	input_triplet_pre
; only msb used
	txa
	pha
	asl
	asl
	ora	#$03
	sta	ram_kernal_start+[rk_sm1-rk_sysline]+1
	pla
	ora	#$40
	sta	ram_kernal_start+[rk_sm2-rk_sysline]+1

	jsr	print_cr
	jsr	print_cr

RAM_KERNAL_LEN equ	ram_kernal_end-ram_kernal_start
	ldx	#RAM_KERNAL_LEN
csrd_lp1:
	lda	ram_kernal_start-1,x
	sta	kernal_buffer-RAM_KERNAL_LEN-1,x
	dex
	bne	csrd_lp1

csrd_lp2:
	lda	#<filename_msg
	ldy	#>filename_msg
	jsr	print
	jsr	input_filename
	jsr	print_cr

;check length, exit if = 0
	lda	$b7
	bne	csrd_skp4
	jmp	sa_exit_refresh

csrd_skp4:
;check if directory
	ldy	#0
	lda	($bb),y
	cmp	#"$"
	bne	csrd_skp3

	jsr	print_cr
	jsr	show_dir
	jsr	print_cr
	jmp	csrd_lp2

csrd_skp3:
	lda	#"N"
	sta	rawmode_zp

	lda	#<rk_sysline
	sta	ptr_zp
	lda	#>rk_sysline
	sta	ptr_zp+1
	lda	#<(kernal_buffer-RAM_KERNAL_LEN)
	sta	rptr_zp
	lda	#>(kernal_buffer-RAM_KERNAL_LEN)
	sta	rptr_zp+1
	lda	#<kernal_buffer_end
	sta	eptr_zp
	lda	#>kernal_buffer_end
	sta	eptr_zp+1
	jmp	cmd_save_data_common
	
;**************************************************************************
;*
;* NAME  cmd_save_data
;*
;* DESCRIPTION
;*
;******
cmd_save_data:
	lda	#<savefile_msg
	ldy	#>savefile_msg
	jsr	print

csd_lp2:
	lda	#<filename_msg
	ldy	#>filename_msg
	jsr	print
	jsr	input_filename
	jsr	print_cr

;check length, exit if = 0
	lda	$b7
	bne	csd_skp4
	jmp	sa_exit_refresh

csd_skp4:
;check if directory
	ldy	#0
	lda	($bb),y
	cmp	#"$"
	bne	csd_skp3

	jsr	print_cr
	jsr	show_dir
	jsr	print_cr
	jmp	csd_lp2

csd_skp3:
	lda	#<rawdata_msg
	ldy	#>rawdata_msg
	jsr	print
	lda	#"N"
	jsr	input_y_n_pre
	sta	rawmode_zp
	jsr	print_cr

	lda	#<$e000
	sta	ptr_zp
	lda	#>$e000
	sta	ptr_zp+1
	lda	#<kernal_buffer
	sta	rptr_zp
	lda	#>kernal_buffer
	sta	rptr_zp+1
	lda	#<kernal_buffer_end
	sta	eptr_zp
	lda	#>kernal_buffer_end
	sta	eptr_zp+1
	jmp	cmd_save_data_common

;**************************************************************************
;*
;* NAME  cmd_save_data_common
;*
;* DESCRIPTION
;*
;******
cmd_save_data_common:
; Print "SAVING <name>"  (skipping the direct mode check at $f68f)
 	jsr	$f693

; use last accessed device
	lda	#1
	ldx	$ba
	ldy	#1
	jsr	$ffba

	jsr	$ffc0

; make it default output
	ldx	#1
	jsr	$ffc9

	lda	rawmode_zp
	cmp	#"Y"
	beq	csd_skp2
; the load address is just the kernal
 	lda	ptr_zp
	jsr	$ffd2
 	lda	ptr_zp+1
	jsr	$ffd2
csd_skp2:

	ldy	#0
csd_lp1:
	lda	(rptr_zp),y
	jsr	$ffd2

	lda	$90		; check status, exit if fail
	and	#%10000011
	bne	csd_fl1	

	inc	rptr_zp
	bne	csd_skp1
	inc	rptr_zp+1
csd_skp1:
	lda	eptr_zp
	cmp	rptr_zp
	bne	csd_lp1
	lda	eptr_zp+1
	cmp	rptr_zp+1
	bne	csd_lp1
	
	lda	#0
csd_fl1:
	php
; restore default output
	jsr	$ffcc
; and close file
	lda	#1
	jsr	$ffc3

	jsr	print_cr
	
; pop the status and check
	plp
	bne	csd_fl2

csd_ex2:
	lda	#<ok_msg
	ldy	#>ok_msg
csd_ex1:
	jsr	print
	jmp	sa_wait_key

csd_fl2:
	lda	#<dfailed_msg
	ldy	#>dfailed_msg
	jmp	csd_ex1

	
;**************************************************************************
;*
;* NAME  cmd_test_kernal
;*
;* DESCRIPTION
;*
;******
cmd_test_kernal:
	lda	#<testkernal_msg
	ldy	#>testkernal_msg
	jsr	print

	jsr	ask_sure
	bcc	ctk_ex1

	lda	#<hook_msg
	ldy	#>hook_msg
	jsr	print
	lda	#"Y"
	jsr	input_y_n_pre
	pha
	jsr	print_cr

	sei

	pla
	cmp	#"Y"
	bne	ctk_skp1

; install hook
	sac	#$ee
	lda	#$06
	sac	#$00
	ldx	#hook_end-hook_start-1
ctk_lp1:
	lda	hook_start,x
	sta	$8000,x
	dex
	bpl	ctk_lp1
	
ctk_skp1:
	sac	#$ee
	lda	#$07
	sac	#$00
; kernal_buffer -> $a000 ($20 pages)
	lda	#>kernal_buffer
	ldy	#$a0
	ldx	#$20
	jsr	mr_copy

	sac	#$ee
	lda	#$02
	sac	#$00

	lda	#1
	sta	$d03f
	lda	#$41
	sta	$d100
	lda	#0
	sta	$d03f
	
	jmp	$fce2

ctk_ex1:
	jmp	sa_lp3

hook_start:
	rorg	$8000
hook:
	dc.w	cold_start
	dc.w	0
	dc.b	"D"|$80,"T"|$80,"V"|$80,"8","0"
cold_start:
	sei
	lda	#1
	sta	$d03f
	lda	#$41
	sta	$d100
	lda	#0
	sta	$d03f
	ldx	#cs_len-1
cs_lp1:
	lda	cs_code,x
	sta	$0120,x
	dex
	bpl	cs_lp1
	sac	$ee
	jmp	$0120
cs_code:
	lda	#$02
	sac	$00
	jmp	($fffc)
cs_len	equ	.-cs_code
	rend
hook_end:

;**************************************************************************
;*
;* NAME  mr_copy
;*
;* DESCRIPTION
;*   -
;*
;******
; copy Acc=MSB of src, Y=MSB of dest, X=num pages
mr_copy:
	sta	ptr_zp+1
	sty	ptr2_zp+1
	ldy	#0
	sty	ptr_zp
	sty	ptr2_zp
mrc_lp1:
	lda	(ptr_zp),y
	sta	(ptr2_zp),y
	iny
	bne	mrc_lp1
	inc	ptr_zp+1
	inc	ptr2_zp+1
	dex
	bne	mrc_lp1
	rts
	
;**************************************************************************
;*
;* NAME  applypatch
;*
;* DESCRIPTION
;*   Install a patch
;*
;******
applypatch:
	stx	src_zp
	sty	src_zp+1

;* main *
ap_lp1:
	jsr	ap_getbase
	jsr	ap_getlen

; if len is zero, we found the end.
	lda	len_zp
	ora	len_zp+1
	beq	ap_ex1


ap_lp2:
	jsr	ap_getbyte
	jsr	ap_putbyte

	lda	len_zp
	bne	ap_skp1
	dec	len_zp+1
ap_skp1:
	dec	len_zp

	lda	len_zp
	ora	len_zp+1
	bne	ap_lp2

	bra	ap_lp1

ap_ex1:
	rts

		
ap_putbyte:
	sta	(dest_zp),y
	inc	dest_zp
	bne	appb_ex1
	inc	dest_zp+1
appb_ex1:
	rts

ap_getbase:
	jsr	ap_getbyte
	sta	dest_zp
	jsr	ap_getbyte
	sec
	sbc	#>($e000-kernal_buffer)
	sta	dest_zp+1
	rts
ap_getlen:
	jsr	ap_getbyte
	sta	len_zp
	jsr	ap_getbyte
	sta	len_zp+1
	rts
ap_getbyte:
	ldy	#0
	lda	(src_zp),y
	eor	#$aa		; unscramble the patch
	inc	src_zp
	bne	apgb_ex1
	inc	src_zp+1
apgb_ex1:
	rts


;**************************************************************************
;*
;* SECTION  SOFT kernal loader
;*   
;******
SK_FLASH_PAGE	equ	$1f
soft_kernal_start:
	rorg	$0801
sk_sysline:
	dc.w	sk_endline
	dc.w	0
	dc.b	$9e,"2061",0
;	        0 SYS2061
;	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
sk_endline:
	dc.w	0
	
sk_enable_kernal:	
	sei
	lda	#1
	sta	$d03f	
sk_sm1:
	lda	#SK_FLASH_PAGE
	sta	$d100

	lda	#0
	sta	$d03f
		
	jmp	($fffc)
	rend
soft_kernal_end:

;**************************************************************************
;*
;* SECTION  RAM kernal loader
;*   
;******
;* Copy kernal into ram $PPe000-$PPffff.
RK_MIRROR_PAGE	equ	$1e

rk_ptr_zp	equ	$fb
rk_ptr2_zp	equ	$fd

ram_kernal_start:
	rorg	$0801
rk_sysline:
	dc.w	rk_endline
	dc.w	0
	dc.b	$9e,"2061",0
;	        0 SYS2061
;	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
rk_endline:
	dc.w	0
	
rk_enable_kernal:	
	sei
	lda	#1
	sta	$d03f	

; move kernal to ram
	sir	$9d
	ldy	#%00000011	; Burst, skip internal cycles
rk_sm1:
	ldx	#RK_MIRROR_PAGE*4 + $03 ; map $PPc000-$PPffff onto $4000-$7fff
	sir	$12

; $e000 -> $6000 ($20 pages)
	lda	#<rk_kernal
	sta	ptr_zp
	lda	#>rk_kernal
	sta	ptr_zp+1

	ldx	#$20
	lda	#$60
	sta	ptr2_zp+1
	ldy	#0
	sty	ptr2_zp
rk_lp1:
	lda	(ptr_zp),y
	sta	(ptr2_zp),y
	iny
	bne	rk_lp1
	inc	ptr_zp+1
	inc	ptr2_zp+1
	dex
	bne	rk_lp1

; map out kernal and basic
	sir	$9d
	ldy	#%00000000
	ldx	#1		; map $004000-$008000 onto $4000-$8000
	sir	$12

rk_sm2:
	lda	#$40 | RK_MIRROR_PAGE
	sta	$d100

	lda	#0
	sta	$d03f
		
	jmp	($fffc)

	
;* here comes the kernal *
rk_kernal:
	rend
ram_kernal_end:

	
;**************************************************************************
;*
;* SECTION  external code
;*   
;******
	include "screen_io.asm"
	include "help.asm"
	
	seg	code
; end of the code segment
code_end	equ	.
	

	
;**************************************************************************
;*
;* SECTION  data
;*   
;******
	seg	data
;**************************************************************************
;*
;* DESCRIPTION
;*   miscellaneous strings.
;*   
;******
menu_msg:
	dc.b	"C     - CREATE PATCHED KERNAL",13
	dc.b	"T     - TEST KERNAL (IN RAM)",13
	dc.b	"L/S   - LOAD/SAVE KERNAL",13	
	dc.b	"W     - SAVE RAM KERNAL",13	
	dc.b	"V     - SAVE SOFT KERNAL LOADER",13	
	dc.b	"$     - DIRECTORY",13
	dc.b	"8/9   - SELECT DRIVE",13
	dc.b	"H     - HELP",13
	dc.b	"X     - EXIT",13
	dc.b	0
anykey_msg:
	dc.b	13,"PRESS ANY KEY.",13,0
ok_msg:
	dc.b	"OK.",13,0

loadfile_msg:
	dc.b	147,"LOAD CUSTOM KERNAL...",13,13,0
savefile_msg:
	dc.b	147,"SAVE KERNAL...",13,13,0
saveramkernal_msg:
	dc.b	147,"SAVE RAM KERNAL...",13,13,0
savesoftkernal_msg:
	dc.b	147,"SAVE SOFT KERNAL LOADER...",13,13,0
ram_addr_msg:
	dc.b	"RAM ADDR ($--E000) $",0
flash_addr_msg:
	dc.b	"FLASH ADDR ($--E000) $",0
testkernal_msg:
	dc.b	"TEST KERNAL (WILL RESET)...",13,13,0
filename_msg:
	dc.b	"FILENAME: ",0
rawdata_msg:
	dc.b	"RAW DATA? ",0
hook_msg:
	dc.b	"LBUTTON+RESET HOOK? ",0
dfailed_msg:
	dc.b	"FAILED!",13,0
exit_msg:
	dc.b	147,"EXITING...",13,0

dtv_hummer_msg:
	dc.b	"DTV OR HUMMER? ",0
dtv_msg:
	dc.b	"DTV",13,0
hummer_msg:
	dc.b	"HUMMER",13,0

reversectrl_msg:
	dc.b	"REVERSE CTRL-KEY FUNCTION IN BOOT? ",0

loadpatch_msg:
	dc.b	13,"REPAIR FLASH LOAD ROUTINE? ",0

flashhook_msg:
	dc.b	13,"PATCH TO CHECK FOR RESET HOOK IN FLASH",13
	dc.b	"AT $1F8000 + IMPROVE DIRECTORY SUPPORT,",13
	dc.b	"APPLY PATCH? ",0

hardvideo_msg:
	dc.b	13,"HARDCODE VIDEO TIMING? ",0
video_d040_msg
	dc.b	"$D040      : $",0
video_d041_msg
	dc.b	13,"$D041/42/43: $",0
video_d04e_msg
	dc.b	13,"$D04E      : $",0
video_d04f_msg
	dc.b	13,"$D04F      : $",0
palette_msg:
	dc.b	13,"IMPROVED PALETTE (ZEE)? ",0
autoload_msg:
	dc.b	13,"AUTOLOAD DTVMENU INSTEAD OF INTRO? ",0

patches_applied_msg:
	dc.b	13,"OK, PATCHED KERNAL IN BUFFER.",0
		
helptext:
	incbin	"patcherhelp_fixed.bin"

kernal3:
	incbin	"kernal3.bin"
kernal3_end:
dtv2_patch:
	incbin	"dtv2_kernal.pch"
	ds.b	4,$aa		; end marker
dtv2_patch_end:
main_patch:
	incbin	"tlr_kernal_main.pch"
	ds.b	4,$aa		; end marker
main_patch_end:
main_hummer_patch:
	incbin	"tlr_kernal_main_hummer.pch"
	ds.b	4,$aa		; end marker
main_hummer_end:
load_patch:
	incbin	"tlr_kernal_load.pch"
	ds.b	4,$aa		; end marker
load_patch_end:
hardvideo_patch:
	incbin	"tlr_kernal_hardvideo.pch"
	ds.b	4,$aa		; end marker
hardvideo_end:
softboot_patch:
	incbin	"tlr_kernal_softboot.pch"
	ds.b	4,$aa		; end marker
softboot_end:
palette_patch:
	incbin	"tlr_kernal_palette.pch"
	ds.b	4,$aa		; end marker
palette_end:
		

; parameters
hummer_flag:
	dc.b	0

; end of the data segment
data_end	equ	.

	
	seg.u	bss
;**************************************************************************
;*
;* SECTION  bss
;*   
;******
	org	$6000
; the buffer must be page aligned.
kernal_buffer:
	ds.b	8192
kernal_buffer_end:
	
; end of the bss segment
bss_end		equ	.
	
; eof
